//---------------------------------------------------------------------------
/*
 * Copyright (c) Allan Petersen, 2001.
 * This is a tutorial for a simple capture system using the win32 api
 * for accessing your webcam
 *
 * (c) Copyright 2001, Allan Petersen
 * ALL RIGHTS RESERVED
 * Permission to use, copy, modify, and distribute this software for
 * any purpose and without fee is hereby granted, provided that the above
 * copyright notice appear in all copies and that both the copyright notice
 * and this permission notice appear in supporting documentation, and that
 * the name of Allan Petersen not be used in advertising
 * or publicity pertaining to distribution of the software without specific,
 * written prior permission.
 *
 * THE MATERIAL EMBODIED ON THIS SOFTWARE IS PROVIDED TO YOU "AS-IS"
 * AND WITHOUT WARRANTY OF ANY KIND, EXPRESS, IMPLIED OR OTHERWISE,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR
 * FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT SHALL ALLAN
 * PETERSEN BE LIABLE TO YOU OR ANYONE ELSE FOR ANY DIRECT,
 * SPECIAL, INCIDENTAL, INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY
 * KIND, OR ANY DAMAGES WHATSOEVER, INCLUDING WITHOUT LIMITATION,
 * LOSS OF PROFIT, LOSS OF USE, SAVINGS OR REVENUE, OR THE CLAIMS OF
 * THIRD PARTIES, WHETHER OR NOT ALLAN PETERSEN HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, ARISING OUT OF OR IN CONNECTION WITH THE
 * POSSESSION, USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Contact Allan Petersen at <support@allanpetersen.com> or visit
 * www.allanpetersen.com
 *
 */
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "c_cap.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

TCap   *Cap;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    int ii;
    TMenuItem *NewItem;

    Timer1->Enabled = false;
    Cap = new TCap (Handle);

    Cap->EnumCapDrv ();

    for (ii=0; ii<Cap->pStringCapDrivers->Count; ii++) {
        NewItem = new TMenuItem(Options1);
        NewItem->Caption = Cap->pStringCapDrivers->Strings[ii];
        NewItem->Tag = ii;
        NewItem->Checked = ii==0 ? true:false;
        NewItem->OnClick =  MyMenyClick;
        Options1->Add (NewItem);
        }
    if (ii > 0 )
        Cap->Connect (0);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::MyMenyClick(TObject *Sender)
{
    int     ii;
    TMenuItem *MenuItem;

    MenuItem = reinterpret_cast  <TMenuItem *> (Sender);

    if (MenuItem) {
        // ---- Disable rest og checked menu
        for (ii=0; ii<Options1->Count; ii++) {
            Options1->Items[ii]->Checked = false;
            }
        MenuItem->Checked = true;
        Cap->Connect (MenuItem->Tag);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Format1Click(TObject *Sender)
{
    Cap->Format ();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Source1Click(TObject *Sender)
{
    Cap->Source ();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
    Close ();    
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{
    if (SavePictureDialog1->Execute ()) {
        Cap->CaptureFrame (SavePictureDialog1->FileName.c_str());
        }
}
//---------------------------------------------------------------------------
